    001/* ========================================================================
    002 * JCommon : a free general purpose class library for the Java(tm) platform
    003 * ========================================================================
    004 *
    005 * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006 *
    007 * Project Info:  http://www.jfree.org/jcommon/index.html
    008 *
    009 * This library is free software; you can redistribute it and/or modify it
    010 * under the terms of the GNU Lesser General Public License as published by
    011 * the Free Software Foundation; either version 2.1 of the License, or
    012 * (at your option) any later version.
    013 *
    014 * This library is distributed in the hope that it will be useful, but
    015 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017 * License for more details.
    018 *
    019 * You should have received a copy of the GNU Lesser General Public
    020 * License along with this library; if not, write to the Free Software
    021 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022 * USA.
    023 *
    024 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025 * in the United States and other countries.]
    026 *
    027 * ----------------------------
    028 * ElementDefinitionHandler.java
    029 * ----------------------------
    030 * (C)opyright 2003-2005, by Thomas Morgner and Contributors.
    031 *
    032 * Original Author:  Thomas Morgner;
    033 * Contributor(s):   David Gilbert (for Object Refinery Limited);
    034 *
    035 * $Id: ElementDefinitionHandler.java,v 1.4 2005/11/14 10:57:22 mungady Exp $
    036 *
    037 * Changes
    038 * -------
    039 * 21-Feb-2003 : Added standard header and Javadocs (DG);
    040 * 29-Apr-2003 : Distilled from the JFreeReport project and moved into JCommon
    041 *
    042 */
    043
    044package org.jfree.xml;
    045
    046import org.xml.sax.Attributes;
    047import org.xml.sax.SAXException;
    048
    049/**
    050 * A element definition handler. The element definition handler is used to
    051 * represent a certain parser state. The current state is set in the parser
    052 * using the pushFactory() method. The parser forwards any incoming SAXEvent
    053 * to the current handler, until the handler is removed with popFactory().
    054 *
    055 * @author Thomas Morgner
    056 */
    057public interface ElementDefinitionHandler {
    058
    059    /**
    060     * Callback to indicate that an XML element start tag has been read by the parser.
    061     *
    062     * @param tagName  the tag name.
    063     * @param attrs  the attributes.
    064     *
    065     * @throws SAXException if a parser error occurs or the validation failed.
    066     */
    067    public void startElement(String tagName, Attributes attrs) throws SAXException;
    068
    069    /**
    070     * Callback to indicate that some character data has been read.
    071     *
    072     * @param ch  the character array.
    073     * @param start  the start index for the characters.
    074     * @param length  the length of the character sequence.
    075     * @throws SAXException if a parser error occurs or the validation failed.
    076     */
    077    public void characters(char[] ch, int start, int length) throws SAXException;
    078
    079    /**
    080     * Callback to indicate that an XML element end tag has been read by the parser.
    081     *
    082     * @param tagName  the tag name.
    083     *
    084     * @throws SAXException if a parser error occurs or the validation failed.
    085     */
    086    public void endElement(String tagName) throws SAXException;
    087
    088    /**
    089     * Returns the parser.
    090     *
    091     * @return The parser.
    092     */
    093    public Parser getParser();
    094
    095}